proc define_signals_S10_10GBase-KR_PHY {} {
	global MAIN_DICT dash clock
	
	set MAIN_DICT {}

	dict set MAIN_DICT var.DEBUG_MODE 1
	
	#In KHz. This is the sampling clock for STP file. 
	set clock 125000

	#10G-KR->1	 40G-KR->4
	dict set MAIN_DICT var.no_of_channels 1
	
	#Total no.of signals to be extracted from .csv file
	dict set MAIN_DICT var.TOTAL_SIGNALS 79
	
	#Total states of Sequencer SM to be extracted from .csv file
	dict set MAIN_DICT var.TOTAL_STATES 16
	
	#List of different hierarchies to be accessed for various signals
	set hierarchy1_patternmatch {SEQ_GEN\.SEQUENCER\|seq_sm\.}
	set hierarchy1 {SEQ_GEN.SEQUENCER|seq_sm.}
	set hierarchy2_patternmatch {SEQ_GEN\.SEQUENCER\|}
	set hierarchy2 {SEQ_GEN.SEQUENCER|}
	set hierarchy3_patternmatch {CHANNEL\|AN_GEN\.AUTO_NEG\|ARB\|an_arb_sm\.}
	set hierarchy3 {CHANNEL|AN_GEN.AUTO_NEG|ARB|an_arb_sm.}
	set hierarchy4_patternmatch {CHANNEL\|AN_GEN\.AUTO_NEG\|ARB\|}
	set hierarchy4 {CHANNEL|AN_GEN.AUTO_NEG|ARB|}
	set hierarchy5_patternmatch {CHANNEL\|AN_GEN\.csr_kran_inst\|}
	set hierarchy5 {CHANNEL|AN_GEN.csr_kran_inst|}
	
	set hierarchy6_patternmatch {CHANNEL\|}
	set hierarchy6 {CHANNEL|}
	set hierarchy7_patternmatch {CHANNEL\|LT_CHNL\.}
	set hierarchy7 {CHANNEL|LT_CHNL.}
	
	set hierarchy8_patternmatch {CHANNEL\|native_phy_xcvr_inst\|}
	set hierarchy8 {CHANNEL|native_phy_xcvr_inst|}
	
	#List of signals to be read from CSV file.  Whenever below list is updated, please update the parameter "TOTAL_SIGNALS" and "TOTAL_STATES" 
	#Sequencer SM States. Signals representing SSM states should be defined first, in the below list of signals. Restriction coming from FOR loop of procedure "find_start_stop_time_of_states"
		dict set MAIN_DICT var.signal1 "SSM_ENABLE"
		dict set MAIN_DICT var.signal1.patMatch "[set hierarchy1_patternmatch]SSM_ENABLE"
		dict set MAIN_DICT var.signal2 "SSM_RC_AN"
		dict set MAIN_DICT var.signal2.patMatch "[set hierarchy1_patternmatch]SSM_RC_AN"
		dict set MAIN_DICT var.signal3 "SSM_AN_ABL"
		dict set MAIN_DICT var.signal3.patMatch "[set hierarchy1_patternmatch]SSM_AN_ABL"
		dict set MAIN_DICT var.signal4 "SSM_AN_CHK"
		dict set MAIN_DICT var.signal4.patMatch "[set hierarchy1_patternmatch]SSM_AN_CHK"
		dict set MAIN_DICT var.signal5 "SSM_RC_LT"
		dict set MAIN_DICT var.signal5.patMatch "[set hierarchy1_patternmatch]SSM_RC_LT"
		dict set MAIN_DICT var.signal6 "SSM_LT_CHK"	
		dict set MAIN_DICT var.signal6.patMatch "[set hierarchy1_patternmatch]SSM_LT_CHK"
		dict set MAIN_DICT var.signal7 "SSM_RC_10G"	
		dict set MAIN_DICT var.signal7.patMatch "[set hierarchy1_patternmatch]SSM_RC_10G"	
		dict set MAIN_DICT var.signal8 "SSM_10G_CHK"		
		dict set MAIN_DICT var.signal8.patMatch "[set hierarchy1_patternmatch]SSM_10G_CHK"		
		dict set MAIN_DICT var.signal9 "SSM_LNK_RDY"
		dict set MAIN_DICT var.signal9.patMatch "[set hierarchy1_patternmatch]SSM_LNK_RDY"
		dict set MAIN_DICT var.signal10 "SSM_LR_WAIT"  
		dict set MAIN_DICT var.signal10.patMatch "[set hierarchy1_patternmatch]SSM_LR_WAIT"  
		dict set MAIN_DICT var.signal11 "SSM_RC_GE"
		dict set MAIN_DICT var.signal11.patMatch "[set hierarchy1_patternmatch]SSM_RC_GE"
		dict set MAIN_DICT var.signal12 "SSM_GE_CHK"
		dict set MAIN_DICT var.signal12.patMatch "[set hierarchy1_patternmatch]SSM_GE_CHK"
		dict set MAIN_DICT var.signal13 "SSM_GE_PDF"
		dict set MAIN_DICT var.signal13.patMatch "[set hierarchy1_patternmatch]SSM_GE_PDF"
		dict set MAIN_DICT var.signal14 "SSM_RC_XAU"
		dict set MAIN_DICT var.signal14.patMatch "[set hierarchy1_patternmatch]SSM_RC_XAU"
		dict set MAIN_DICT var.signal15 "SSM_XAU_CHK"
		dict set MAIN_DICT var.signal15.patMatch "[set hierarchy1_patternmatch]SSM_XAU_CHK"
		dict set MAIN_DICT var.signal16 "SSM_XAU_PDF"
		dict set MAIN_DICT var.signal16.patMatch "[set hierarchy1_patternmatch]SSM_XAU_PDF"	
	#LF Timer
		dict set MAIN_DICT var.signal17 "stage_one"
		dict set MAIN_DICT var.signal17.patMatch "[set hierarchy2_patternmatch]stage_one\\\[9\\.\\.0\\\]"
		dict set MAIN_DICT var.signal18 "stage_two"
		dict set MAIN_DICT var.signal18.patMatch "[set hierarchy2_patternmatch]stage_two\\\[9\\.\\.0\\\]"
		dict set MAIN_DICT var.signal19 "stage_trey"
		dict set MAIN_DICT var.signal19.patMatch "[set hierarchy2_patternmatch]stage_trey\\\[6\\.\\.0\\\]"
		dict set MAIN_DICT var.signal20 "pcs_mode_rc"
		dict set MAIN_DICT var.signal20.patMatch "[set hierarchy2_patternmatch]pcs_mode_rc\\\[5\\.\\.0\\\]"
	#Auto Neg
		dict set MAIN_DICT var.signal21 "AN_ARB_ENABLE"
		dict set MAIN_DICT var.signal21.patMatch "[set hierarchy3_patternmatch]AN_ARB_ENABLE"
		dict set MAIN_DICT var.signal22 "AN_ARB_TX_DIS"
		dict set MAIN_DICT var.signal22.patMatch "[set hierarchy3_patternmatch]AN_ARB_TX_DIS"
		dict set MAIN_DICT var.signal23 "AN_ARB_ABL_DET"
		dict set MAIN_DICT var.signal23.patMatch "[set hierarchy3_patternmatch]AN_ARB_ABL_DET"
		dict set MAIN_DICT var.signal24 "AN_ARB_ACK_DET"
		dict set MAIN_DICT var.signal24.patMatch "[set hierarchy3_patternmatch]AN_ARB_ACK_DET"
		dict set MAIN_DICT var.signal25 "AN_ARB_COMP_ACK"
		dict set MAIN_DICT var.signal25.patMatch "[set hierarchy3_patternmatch]AN_ARB_COMP_ACK"
		dict set MAIN_DICT var.signal26 "AN_ARB_AN_GOOD"
		dict set MAIN_DICT var.signal26.patMatch "[set hierarchy3_patternmatch]AN_ARB_AN_GOOD"
		dict set MAIN_DICT var.signal27 "AN_ARB_NXT_PAGE"
		dict set MAIN_DICT var.signal27.patMatch "[set hierarchy3_patternmatch]AN_ARB_NXT_PAGE"
		dict set MAIN_DICT var.signal28 "ackm_wd"
		dict set MAIN_DICT var.signal28.patMatch "[set hierarchy4_patternmatch]ackm_wd\\\[48\\.\\.1\\\]"
		dict set MAIN_DICT var.signal29 "page_data"
		dict set MAIN_DICT var.signal29.patMatch "[set hierarchy4_patternmatch]page_data\\\[48\\.\\.1\\\]"
		dict set MAIN_DICT var.signal30 "an_enable"
		dict set MAIN_DICT var.signal30.patMatch "[set hierarchy2_patternmatch]an_enable"
		dict set MAIN_DICT var.signal31 "lcl_tech"
		dict set MAIN_DICT var.signal31.patMatch "[set hierarchy4_patternmatch]lcl_tech\\\[24\\.\\.0\\\]"
		dict set MAIN_DICT var.signal32 "lp_tech"
		dict set MAIN_DICT var.signal32.patMatch "[set hierarchy5_patternmatch]lp_tech\\\[24\\.\\.0\\\]"
		dict set MAIN_DICT var.signal33 "an_done"
		dict set MAIN_DICT var.signal33.patMatch "[set hierarchy2_patternmatch]an_done"
		dict set MAIN_DICT var.signal34 "hcd_40g"
		dict set MAIN_DICT var.signal34.patMatch "[set hierarchy2_patternmatch]hcd_40g"
		dict set MAIN_DICT var.signal35 "hcd_kr"
		dict set MAIN_DICT var.signal35.patMatch "[set hierarchy2_patternmatch]hcd_kr"
		dict set MAIN_DICT var.signal36 "hcd_xaui"
		dict set MAIN_DICT var.signal36.patMatch "[set hierarchy2_patternmatch]hcd_xaui"
		dict set MAIN_DICT var.signal37 "hcd_gige"
		dict set MAIN_DICT var.signal37.patMatch "[set hierarchy2_patternmatch]hcd_gige"
	#Link Training
		dict set MAIN_DICT var.signal38 "lt_enable"
		dict set MAIN_DICT var.signal38.patMatch "[set hierarchy6_patternmatch]lt_enable"
		dict set MAIN_DICT var.signal39 "frame_lock"
		dict set MAIN_DICT var.signal39.patMatch "[set hierarchy6_patternmatch]frame_lock"
		dict set MAIN_DICT var.signal40 "lcl_rx_ready"
		dict set MAIN_DICT var.signal40.patMatch "[set hierarchy7_patternmatch]lcl_rx_ready"
		dict set MAIN_DICT var.signal41 "rx_trained"
		dict set MAIN_DICT var.signal41.patMatch "[set hierarchy6_patternmatch]rx_trained"
		dict set MAIN_DICT var.signal42 "rmt_rx_ready"
		dict set MAIN_DICT var.signal42.patMatch "[set hierarchy6_patternmatch]rmt_rx_ready"
		dict set MAIN_DICT var.signal43 "lcl_coefh"
		dict set MAIN_DICT var.signal43.patMatch "[set hierarchy6_patternmatch]lcl_coefh\\\[13\\.\\.12\\\]"
		dict set MAIN_DICT var.signal44 "lcl_coefl"
		dict set MAIN_DICT var.signal44.patMatch "[set hierarchy6_patternmatch]lcl_coefl\\\[5\\.\\.0\\\]"
		dict set MAIN_DICT var.signal45 "lcl_coef_sts"
		dict set MAIN_DICT var.signal45.patMatch "[set hierarchy6_patternmatch]lcl_coef_sts\\\[5\\.\\.0\\\]"
		dict set MAIN_DICT var.signal46 "rmt_coef_updh"
		dict set MAIN_DICT var.signal46.patMatch "[set hierarchy6_patternmatch]rmt_coef_updh\\\[13\\.\\.12\\\]"
		dict set MAIN_DICT var.signal47 "rmt_coef_updl"
		dict set MAIN_DICT var.signal47.patMatch "[set hierarchy6_patternmatch]rmt_coef_updl\\\[5\\.\\.0\\\]"
		dict set MAIN_DICT var.signal48 "rmt_coef_sts"
		dict set MAIN_DICT var.signal48.patMatch "[set hierarchy6_patternmatch]rmt_coef_sts\\\[5\\.\\.0\\\]"
	#DATA	
		dict set MAIN_DICT var.signal49 "rx_block_lock"
		dict set MAIN_DICT var.signal49.patMatch "[set hierarchy6_patternmatch]rx_block_lock"
		dict set MAIN_DICT var.signal50 "rx_data_ready"
		dict set MAIN_DICT var.signal50.patMatch "[set hierarchy6_patternmatch]rx_data_ready"
		dict set MAIN_DICT var.signal51 "rx_hi_ber"
		dict set MAIN_DICT var.signal51.patMatch "[set hierarchy6_patternmatch]rx_hi_ber"
		dict set MAIN_DICT var.signal52 "rx_is_lockedtodata"
		dict set MAIN_DICT var.signal52.patMatch "[set hierarchy6_patternmatch]rx_is_lockedtodata"
		dict set MAIN_DICT var.signal53 "rx_is_lockedtoref"
		dict set MAIN_DICT var.signal53.patMatch "[set hierarchy6_patternmatch]rx_is_lockedtoref"
		dict set MAIN_DICT var.signal54 "tx_digitalreset"
		dict set MAIN_DICT var.signal54.patMatch "[set hierarchy8_patternmatch]tx_digitalreset\\\[0\\\]"
		dict set MAIN_DICT var.signal55 "tx_digitalreset_stat"
		dict set MAIN_DICT var.signal55.patMatch "[set hierarchy8_patternmatch]tx_digitalreset_stat\\\[0\\\]"
		dict set MAIN_DICT var.signal56 "tx_analogreset"
		dict set MAIN_DICT var.signal56.patMatch "[set hierarchy8_patternmatch]tx_analogreset\\\[0\\\]"
		dict set MAIN_DICT var.signal57 "tx_analogreset_stat"
		dict set MAIN_DICT var.signal57.patMatch "[set hierarchy8_patternmatch]tx_analogreset_stat\\\[0\\\]"
		dict set MAIN_DICT var.signal58 "rx_digitalreset"
		dict set MAIN_DICT var.signal58.patMatch "[set hierarchy8_patternmatch]rx_digitalreset\\\[0\\\]"
		dict set MAIN_DICT var.signal59 "rx_digitalreset_stat"
		dict set MAIN_DICT var.signal59.patMatch "[set hierarchy8_patternmatch]rx_digitalreset_stat\\\[0\\\]"
		dict set MAIN_DICT var.signal60 "rx_analogreset"
		dict set MAIN_DICT var.signal60.patMatch "[set hierarchy8_patternmatch]rx_analogreset\\\[0\\\]"
		dict set MAIN_DICT var.signal61 "rx_analogreset_stat"
		dict set MAIN_DICT var.signal61.patMatch "[set hierarchy8_patternmatch]rx_analogreset_stat\\\[0\\\]"

	#Next states of Sequencer SM States. Must to have these for accuracy of the timings reported by Link Analysis.
		dict set MAIN_DICT var.signal62 "nxt_seq_sm.SSM_ENABLE"
		dict set MAIN_DICT var.signal62.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_ENABLE"
		dict set MAIN_DICT var.signal63 "nxt_seq_sm.SSM_RC_AN"
		dict set MAIN_DICT var.signal63.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_RC_AN"
		dict set MAIN_DICT var.signal64 "nxt_seq_sm.SSM_AN_ABL"
		dict set MAIN_DICT var.signal64.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_AN_ABL"
		dict set MAIN_DICT var.signal65 "nxt_seq_sm.SSM_AN_CHK"
		dict set MAIN_DICT var.signal65.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_AN_CHK"
		dict set MAIN_DICT var.signal66 "nxt_seq_sm.SSM_RC_LT"
		dict set MAIN_DICT var.signal66.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_RC_LT"
		dict set MAIN_DICT var.signal67 "nxt_seq_sm.SSM_LT_CHK"	
		dict set MAIN_DICT var.signal67.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_LT_CHK"
		dict set MAIN_DICT var.signal68 "nxt_seq_sm.SSM_RC_10G"	
		dict set MAIN_DICT var.signal68.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_RC_10G"	
		dict set MAIN_DICT var.signal69 "nxt_seq_sm.SSM_10G_CHK"		
		dict set MAIN_DICT var.signal69.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_10G_CHK"		
		dict set MAIN_DICT var.signal70 "nxt_seq_sm.SSM_LNK_RDY"
		dict set MAIN_DICT var.signal70.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_LNK_RDY"
		dict set MAIN_DICT var.signal71 "nxt_seq_sm.SSM_LR_WAIT"  
		dict set MAIN_DICT var.signal71.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_LR_WAIT"  
		dict set MAIN_DICT var.signal72 "nxt_seq_sm.SSM_RC_GE"
		dict set MAIN_DICT var.signal72.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_RC_GE"
		dict set MAIN_DICT var.signal73 "nxt_seq_sm.SSM_GE_CHK"
		dict set MAIN_DICT var.signal73.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_GE_CHK"
		dict set MAIN_DICT var.signal74 "nxt_seq_sm.SSM_GE_PDF"
		dict set MAIN_DICT var.signal74.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_GE_PDF"
		dict set MAIN_DICT var.signal75 "nxt_seq_sm.SSM_RC_XAU"
		dict set MAIN_DICT var.signal75.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_RC_XAU"
		dict set MAIN_DICT var.signal76 "nxt_seq_sm.SSM_XAU_CHK"
		dict set MAIN_DICT var.signal76.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_XAU_CHK"
		dict set MAIN_DICT var.signal77 "nxt_seq_sm.SSM_XAU_PDF"
		dict set MAIN_DICT var.signal77.patMatch "[set hierarchy2_patternmatch]nxt_seq_sm.SSM_XAU_PDF"	

	#Additions in v2.0
		dict set MAIN_DICT var.signal78 "rx_parallel_data"
		dict set MAIN_DICT var.signal78.patMatch "[set hierarchy8_patternmatch]rx_parallel_data\\\[79\\.\\.0\\\]"
		dict set MAIN_DICT var.signal79 "tx_parallel_data"
		dict set MAIN_DICT var.signal79.patMatch "[set hierarchy8_patternmatch]tx_parallel_data\\\[79\\.\\.0\\\]"
		#dict set MAIN_DICT var.signal78 "xgmii_rx_dc"
		#dict set MAIN_DICT var.signal78.patMatch "[set hierarchy6_patternmatch]xgmii_rx_dc"
		#dict set MAIN_DICT var.signal79 "xgmii_tx_dc"
		#dict set MAIN_DICT var.signal79.patMatch "[set hierarchy6_patternmatch]xgmii_tx_dc"
		
	#Define the KR modes and the respective SSM states in each mode
	#Define the total KR modes and mapping of SEQ SM states to KR modes
	dict set MAIN_DICT var.no_of_KRstates "SEQ_Initialize Auto_Neg Link_Training Data"
	dict set MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] 0] "SSM_ENABLE"
	dict set MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] 1] "SSM_RC_AN SSM_AN_ABL SSM_AN_CHK"
	dict set MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] 2] "SSM_RC_LT SSM_LT_CHK"
	dict set MAIN_DICT var.[lindex [dict get $MAIN_DICT var.no_of_KRstates] 3] "SSM_RC_10G SSM_10G_CHK SSM_LNK_RDY SSM_LR_WAIT SSM_RC_GE SSM_GE_CHK SSM_GE_PDF SSM_RC_XAU SSM_XAU_CHK SSM_XAU_PDF" 
	

	#AN Technology Look Up Table
	dict set MAIN_DICT AN_tech_map.0 "xxx"
	dict set MAIN_DICT AN_tech_map.1 "1000BASE-KX"
	dict set MAIN_DICT AN_tech_map.2 "10GBASE-KX4"
	dict set MAIN_DICT AN_tech_map.3 "10GBASE-KR"
	dict set MAIN_DICT AN_tech_map.4 "40GBASE-KR4"
	dict set MAIN_DICT AN_tech_map.5 "40GBASE-CR4"
	dict set MAIN_DICT AN_tech_map.6 "100GBASE-CR10"
	dict set MAIN_DICT AN_tech_map.7 "100GBASE-KP4"
	dict set MAIN_DICT AN_tech_map.8 "100GBASE-KR4"
	dict set MAIN_DICT AN_tech_map.9 "100GBASE-CR4"
	dict set MAIN_DICT AN_tech_map.10 "25GBASE-KR-S"
	dict set MAIN_DICT AN_tech_map.11 "25GBASE-KR"
	dict set MAIN_DICT AN_tech_map.12 Reserved
	dict set MAIN_DICT AN_tech_map.13 Reserved
	dict set MAIN_DICT AN_tech_map.14 "50GBASE-KR"
	dict set MAIN_DICT AN_tech_map.15 "100GBASE-KR2"
	dict set MAIN_DICT AN_tech_map.16 "200GBASE-KR4"
	dict set MAIN_DICT AN_tech_map.17 Reserved
	dict set MAIN_DICT AN_tech_map.18 Reserved
	dict set MAIN_DICT AN_tech_map.19 Reserved
	dict set MAIN_DICT AN_tech_map.20 Reserved
	dict set MAIN_DICT AN_tech_map.21 Reserved
	dict set MAIN_DICT AN_tech_map.22 Reserved
	dict set MAIN_DICT AN_tech_map.23 Reserved
	dict set MAIN_DICT AN_tech_map.24 Reserved
	dict set MAIN_DICT AN_tech_map.25 Reserved
	
	#Variables Initialization
	dict set MAIN_DICT var.TOTAL_SAMPLES 0
	dict set MAIN_DICT var.TOTAL_SEQ_STATES_TRAVERSED  0
	dict set MAIN_DICT var.TOTAL_KR_STATES_TRAVERSED 0
	#dict set MAIN_DICT var.IPtype [dashboard_get_property $dash eth_IP_selection selectedItem]
	for {set j 1} {$j <= [dict get $MAIN_DICT var.TOTAL_SIGNALS]} {incr j}	{
		dict set MAIN_DICT var.Xsignal$j 0
		dict set MAIN_DICT var.Ysignal$j 0
	} 
}